% (C) Mario Guimaraes 17 Nov 2001

function pop = genesis(asubjects, achosensubs, nSubsMulticast, aclientsubs, nSubs)

global bIsSpatial nclients nsubjects ngroups npopsize

% Dimensiona a populacao
%   pop{individuo}{grupo} = [1 2 3]
pop = cell(npopsize, 1);

for i = 1:npopsize
    pop{i} = cell(ngroups, 1);
end

nhalfpop = fix(npopsize/2);

% "Flooding"
pop{1}{1} = achosensubs; % achosensubs esta' ordenado por defeito

% "Round-Robin" de assuntos (todas as subscricoes de um assunto num mesmo grupo)
for i = 2:nhalfpop
    asubjIDs = randperm(nsubjects);
    
    for g = 1:ngroups
        pop{i}{g} = sort([asubjects{asubjIDs(g:ngroups:nsubjects)}]);
    end
end

if bIsSpatial
    % "Round-Robin" de clientes
    for i = nhalfpop+1:npopsize
        a = uint16(randperm(nclients));
        ahelper = uint8(zeros(1,nSubs));
        ahelper2 = uint8(zeros(1,nSubs));
        ahelper2(achosensubs) = 1;
        
        for g = 1:ngroups
            asubs = myunique([aclientsubs{a(g:ngroups:nclients)}]);
            asubs = asubs(find(ahelper2(asubs)));
            d = find(~ahelper(asubs));
            ahelper(asubs(d)) = 1;
            pop{i}{g} = asubs(d);
        end
    end
else
    % "Round-Robin" de subscricoes
    for i = nhalfpop+1:npopsize
        a = uint16(randperm(nSubsMulticast));

        for g = 1:ngroups
            pop{i}{g} = sort(achosensubs(a(g:ngroups:nSubsMulticast)));
        end
    end
end