function c = mysetdiff(a,b)
%MYSETDIFF Set difference.
%   MYSETDIFF(A,B) when A and B are vectors returns the values
%   in A that are not in B. The result will be sorted.  A and B
%   can be cell arrays of strings.

% Make sure a and b contain unique elements.
a = myunique(a);
b = myunique(b);

% Find matching entries
[c,ndx] = sort([a,b]);

% d indicates the location of matching entries
d = find(c(1:end-1)==c(2:end));
ndx([d;d+1]) = []; % Remove all matching entries

d = ndx <= length(a); % Values in a that don't match.
c = a(ndx(d));