% (C) Mario Guimaraes 31 Dez 2001

function plotgen(filename, aidx, sparams)

toks{1} = 'f';
toks{2} = 'std';
toks{3} = 'gap';

try
    load(strcat('runs\history\', filename, '.mat'));
catch
    error(sprintf('History file %s not found.', filename));
end

if nargin <= 1
    aidx = 1:size(ahistory.genkey, 1);
    atok = 1;
else
    if isempty(aidx), aidx = 1:size(ahistory.genkey, 1); end;
    
    if nargin == 2
        atok = 1;
    else
        i = 1;
        [t, sparams] = strtok(sparams, ',');
        
        while ~isempty(t)
            t = rmvspc(t);
            
            for j = 1:size(toks, 2)
                if strcmp(t, toks{j})
                    atok(i) = j;
                    i = i + 1;  
                end
            end
            
            [t, sparams] = strtok(sparams, ',');
        end
    end
end

nlen = length(atok);

if nlen == 0, error('No data to plot !'); end;

col = 1;

for idx = aidx
    try
        g = load(strcat('runs\', ahistory.genkey{idx}, '.mat'));
    catch
        warning(sprintf('Genetic file %s not found.', ahistory.genkey{idx}));
    end

    aplotdata(:,col:(col+nlen-1)) = g.agendata(:,atok);
    col = col + nlen;
end

plot(aplotdata);


function strout = rmvspc(s)
d = find(s ~= ' ');
strout = s(d);