% (C) Mario Guimaraes 24 Nov 2001

function cenfile = runcenary(bIsSpatial_, nsubjects_, nsbjcategories_, maxsbj_power_, natoms_, maxatom_weigth_, ...
    nclients_, psubjects_, nminradius_, nmaxradius_, nminsubspercli_, nmaxsubspercli_)

if (~bIsSpatial_ & nsubjects_/nsbjcategories_ ~= fix(nsubjects_/nsbjcategories_))
    error('Error: nsubjects must be a multiple of nsbjcategories !');
end;

if (natoms_/32 ~= fix(natoms_/32)), error('Error: natoms must be a multiple of 32 !'); end;

global root;
global nseed;
global bIsSpatial;
global nsubjects;
global nsbjcategories;
global maxsbj_power;
global natoms;
global maxatom_weigth;
global nclients;
global psubjects;
global nminradius;
global nmaxradius;
global nminsubspercli;
global nmaxsubspercli;

nseed = nclients_;
bIsSpatial = bIsSpatial_;
nsubjects = nsubjects_;
nsbjcategories = nsbjcategories_;
maxsbj_power = maxsbj_power_;
natoms = natoms_;
maxatom_weigth = maxatom_weigth_;
nclients = nclients_;
psubjects = psubjects_;
nminradius = nminradius_;
nmaxradius = nmaxradius_;
nminsubspercli = nminsubspercli_;
nmaxsubspercli = nmaxsubspercli_;

clear bIsSpatial_ nsubjects_ nsbjcategories_ maxsbj_power_ natoms_ maxatom_weigth_
clear nclients_ psubjects_ nminradius_ nmaxradius_ nminsubspercli_ nmaxsubspercli_

cenname = strcat('cen_spc', num2str(bIsSpatial), ...
    '_sbj', num2str(nsubjects), '_cat',  num2str(nsbjcategories), '_pow', num2str(maxsbj_power), '_ato', num2str(natoms), ...
    '_atow', num2str(maxatom_weigth), '_cli', num2str(nclients), '_psbj', num2str(psubjects), '_minr', num2str(nminradius), ...
    '_maxr', num2str(nmaxradius), '_minsub', num2str(nminsubspercli), '_maxsub', num2str(nmaxsubspercli));

cenfile = strcat(root, '\runs\', cenname, '\cdata.mat');

if ~exist(cenfile, 'file')
    rand('state', nseed);
    [aWeights, asubjects, asubscriptions, aclients, aclientsubs, aclient_bin_subs, nSubs] = gen_subdata;
    [asubjects, achosensubs] = filter_sub(asubjects, asubscriptions, aclients, aWeights);
    nSubsMulticast = length(achosensubs);
    nSubsUnicast = nSubs - nSubsMulticast;
    aWeightsCS = cumsum(aWeights(:));
    if ~exist(strcat(root, '\runs\', cenname), 'dir'), mkdir(root, strcat('runs\', cenname)); end;
    save(cenfile, '-mat');
end