% (C) Mario Guimaraes 16 Dez 2001

function genetic_file = rungenetic(cenname, nMaxIteration_, npopsize_, ngroups_, useElitism_, pCrossover_, pMutation_, ...
    pSwitchCrossover_, pSwitchSelection_, pTournament_, ...
    asubjects, achosensubs, aclientsubs, asubscriptions, aclients, aclient_bin_subs, aWeights, nSubsMulticast, nSubs)

if (npopsize_/2 ~= fix(npopsize_/2)), error('Error: npopsize must be even !'); end;

global root;
global nseed;
global nMaxIteration;
global npopsize;
global ngroups;
global useElitism;
global pCrossover;
global pMutation;
global pSwitchCrossover;
global pSwitchSelection;
global pTournament;

nMaxIteration = nMaxIteration_;
npopsize = npopsize_;
ngroups = ngroups_;
useElitism = useElitism_;
pCrossover = pCrossover_;
pMutation = pMutation_;
pSwitchCrossover = pSwitchCrossover_;
pSwitchSelection = pSwitchSelection_;
pTournament = pTournament_;

clear nMaxIteration_ npopsize_ ngroups_ useElitism_ pCrossover_ pMutation_

genetic_name = strcat('genetic_pop', num2str(npopsize), '_grp', num2str(ngroups), ...
    '_maxiter', num2str(nMaxIteration), '_elit', num2str(useElitism), '_pc', num2str(pCrossover), '_pm', num2str(pMutation), ...
    '_psc', num2str(pSwitchCrossover), '_pss', num2str(pSwitchSelection), '_pt', num2str(pTournament));
genetic_file = strcat(root, '\runs\', cenname, '\', genetic_name, '.mat');
genkey = strcat(cenname, '\', genetic_name);

if ~exist(genetic_file, 'file')    
    genesis_name = strcat('genesis_pop', num2str(npopsize), '_grp', num2str(ngroups));
    genesis_file = strcat(root, '\runs\', cenname, '\', genesis_name, '.mat');

    if exist(genesis_file, 'file')
        load(genesis_file);
    else
        rand('state', nseed);
        pop = genesis(asubjects, achosensubs, nSubsMulticast, aclientsubs, nSubs);
        save(genesis_file, 'genesis_file', 'npopsize', 'ngroups', 'pop', '-mat');
    end    

    rand('state', nseed);
    [ind0, cost0, indf, costf, solution, cost, iter, agendata] = genetic(pop, ...
        achosensubs, asubscriptions, aclients, aclient_bin_subs, aWeights, nSubsMulticast);
    save(genetic_file, 'genesis_file', 'genetic_file', 'nMaxIteration', 'useElitism', 'pCrossover', 'pMutation', ...    
        'pSwitchCrossover', 'pSwitchSelection', 'pTournament', ...    
        'ind0', 'cost0', 'indf', 'costf', 'solution', 'cost', 'iter', 'agendata', '-mat');
end